#include "framecpp/config.h"

#include "general/AtExit.hh"

#include "framecpp/Version3/FrameSpec.hh"

#include "framecpp/Version3/PTR_STRUCT.hh"
#include "framecpp/Version3/StreamRef.hh"

#include "framecpp/Version3/FrameH.hh"
#include "framecpp/Version3/FrAdcData.hh"
#include "framecpp/Version3/FrDetector.hh"
#include "framecpp/Version3/FrHeader.hh"
#include "framecpp/Version3/FrEndOfFile.hh"
#include "framecpp/Version3/FrEndOfFrame.hh"
#include "framecpp/Version3/FrHistory.hh"
#include "framecpp/Version3/FrMsg.hh"
#include "framecpp/Version3/FrProcData.hh"
#include "framecpp/Version3/FrRawData.hh"
#include "framecpp/Version3/FrSE.hh"
#include "framecpp/Version3/FrSerData.hh"
#include "framecpp/Version3/FrSH.hh"
#include "framecpp/Version3/FrSimData.hh"
#include "framecpp/Version3/FrStatData.hh"
#include "framecpp/Version3/FrSummary.hh"
#include "framecpp/Version3/FrTrigData.hh"
#include "framecpp/Version3/FrVect.hh"

using FrameCPP::Common::FrameSpec;

namespace FrameCPP
{
  namespace Version_3
  {
    static void cleanup_at_exit( );
    static bool init_frame_spec( );

    static FrameSpec::Info*
    spec_info( new FrameSpec::Info( DATA_FORMAT_VERSION,
				    LIBRARY_MINOR_VERSION ) );
    static const bool Initialized = init_frame_spec( );



    static void cleanup_at_exit( )
    {
      /* delete spec_info; */

      /* spec_info = (FrameSpec::Info*)NULL; */
    }

    static bool init_frame_spec( )
    {
      //-----------------------------------------------------------------
      // Register cleanup handler
      //-----------------------------------------------------------------
      General::AtExit::Append( cleanup_at_exit,
			       "FrameCPP::Version3::cleanup_at_exit",
			   0 );
      //-----------------------------------------------------------------
      // Local storage describing implementation of the frame spec
      //---------------------------------------------------------------------
      spec_info->FrameObject( new PTR_STRUCT );
      spec_info->FrameObject( new StreamRef );

      spec_info->FrameObject( new FrameH );
      spec_info->FrameObject( new FrAdcData );
      spec_info->FrameObject( new FrDetector );
      spec_info->FrameObject( new FrEndOfFile );
      spec_info->FrameObject( new FrEndOfFrame );
      spec_info->FrameObject( new FrHeader );
      spec_info->FrameObject( new FrHistory );
      spec_info->FrameObject( new FrMsg );
      spec_info->FrameObject( new FrProcData );
      spec_info->FrameObject( new FrRawData );
      spec_info->FrameObject( new FrSE );
      spec_info->FrameObject( new FrSerData );
      spec_info->FrameObject( new FrSH );
      spec_info->FrameObject( new FrSimData );
      spec_info->FrameObject( new FrStatData );
      spec_info->FrameObject( new FrSummary );
      spec_info->FrameObject( new FrTrigData );
      spec_info->FrameObject( new FrVect );

      //-----------------------------------------------------------------
      // Register with the stream manipulator
      //-----------------------------------------------------------------
      FrameSpec::SpecInfo( FrameSpec::version_type( DATA_FORMAT_VERSION ),
			   spec_info );
      return true;
    }

  } // namespace - Version_3
} // namespace - FrameCPP
